Opened 2 years ago

Closed 2 years ago

#1037 closed Bug (fixed)

Homophonic Subst. Analyzer crashed, if a ciphertext with too many homophones was entered

Reported by: no-reply@… Owned by:
Priority: Unclassified Milestone: CrypTool 2.1 - Release 2018.3
Component: General Keywords:
Cc:

Description

Title: Crash report
Exception at 1/30/2020 3:37:30 AM (UTC time).
User message:
Crashes shortly after I clicked "play". The message in the "Text Input" box was hex code generated by CrypTool v1.4.41 using the Homophonic cipher method. The plaintext is the startup message displayed when opening CrypTool v1.

Below is the cipher text:
80 C6 1F 0C 50 47 09 08 31 FC 8C 92 5B 27 81 D8 10 60 70 BD CA 37 60 A7 5B 85 B9 F8 DC 3F A0 E5 7F 47 FA A5 20 14 92 C8 A6 A7 FC F1 C0 6D
59 3E EF D9 F8 4F 3C CF 50 C7 7F 9E 37 10 89 EF 02 22 66 77 F4 80 67 87 3D 1F 95 A9 73 4A CD 81 0A A9 72 F9 28 DD AB 42 BA A4 74 C1 E5 07
08 FE 1B 92 91 E3 B5 7A 70 CF F3 2E EF 1E EC F0 60 53 EF F6 3E AA A5 A9 71 02 3E D5 BC 28 16 91 27 2E 2D 96 6C FA D8 BE 3D FE C7 AD 5F 31
FC 50 CB 34 98 61 3F E7 51 DF DC AB A5 DB 7D 77 82 0F 8C 63 2A 64 28 AF A7 87 61 2D D0 9E 3C EA 68 28 83 96 07 63 7F BC 7D 49 6C FD 32 FC
C6 F5 61 3C 1D E6 AA 5E 71 EB A0 1B 70 DA 01 05 63 E0 21 C5 62 F3 5C 07 7D 81 3C EF 3E 42 3A 41 B9 89 B1 55 E7 A7 4C 45 0C 20 C8 EE 2C 83
7F BC 3D 1C 52 E6 E9 83 D4 71 FD 41 D4 DB 5E 41 8C B3 83 49 B4 43 5B 14 5F A0 7C 20 C0 7D 3B E0 A5 82 8B 6A 78 7D 31 A2 BB FF 20 20 31 E5
6B 41 97 15 6F 46 5D 41 D1 9B D6 86 7F A1 5F 66 50 7C F5 F9 A8 75 DE 19 BB B1 71 47 FB 3E BE E5 EC 89 C9 66 3D 52 BC 28 86 41 C4 16 5F EF
9E 43 12 A7 B5 7A 93 8C 34 86 7E D7 93 D4 9E A6 82 62 06 98 9C 09 83 C4 53 A6 20 3A B4 F1 C6 69 FF 09 5E 3F E9 AA 9F 49 09 55 6C 83 26 78
5A 0D 33 86 C6 AB DF 43 BB E2 F0 31 99 73 CC 26 3D F8 A5 A2 C7 6E DA 26 3D 27 BB F1 8C F4 6F AC E2 F9 CF 78 48 48 7E 2A 87 E9 1F 0E E4 9C
57 AC B6 45 66 DB 79 C1 2C C6 D7 02 CC C4 8D 43 C1 19 F0 CD 9E 85 BC E4 CB 5C 99 BB FE 47 08 7D 5C 7B 73 C6 E4 62 89 1B 9D B7 E6 EA B4 84
07 E6 7C FE 90 3E D0 98 8B 6E 39 A8 E4 0A 06 15 35 B3 F1 D4 55 31 2E A3 B5 FE 01 98 04 CE E5 CC AB B4 5F 0F 35 5F 7E E6 E9 D9 BD C8 8D C6
97 A0 61 B6 00 E7 FC D3 20 0E 97 0A E0 A5 82 96 6E 4B E4 29 82 0F 5B 59 3B 5A 52 F5 76 B5 98 5C 53 02 FB FD 66 29 7B ED 3C C2 13 A0 BD 9C
82 EF 78 30 15 F3 3E A3 7D F2 21 62 96 95 37 0E CE BB D1 2D 6B 18 6F C3 E7 B7 56 FC C6 7F 85 A0 1C A3 B9 72 A2 C5 90 29 0D B9 3D 38 24 E5
A7 D5 50 E2 73 C7 9F 22 A3 EA C6 E4 11 7D E7 93 35 1D 06 1F EE 8C 27 39 B5 0C 8B BC 97 89 41 F6 67 52 37 D7 16 90 7E 17 D3 4E CA 9B 18 A4
04 7D 36 D2 36 AF D0 37 59 2E EF 11 4D DB 37 EE A7 0F A8 52 3E 9A D2 CA BC E5 18 CF 24 DC CE 2C 75 9D 24 5C 7D CA EB 78 33 0C 7E 98 CA 3F
9C 21 8F 82 CD FC 19 57 1C DC 12 6C 1E 45 FB FA B0 49 1B C3 06 A3 C4 CC 26 AB 6E FD F6 7E B9 16 9F 69 AD 15 BD 7E C3 1C E6 F6 94 6D BD EF
86 F8 30 A1 A9 32 1F AD E7 9E 5A 3E A3 A4 A7 C9 10 39 28 96 95 19 38 72 63 17 32 EE 52 CC 35 AF AE 69 34 43 10 F5 71 FE 2E 5B C0 FF 74 40
5F 3E 04 26 4B 5D 12 CD FC CE D2 D5 27 81 06 F9 A4 8D E3 DB D8 51 72 09 A9 9B A1 91 11 E4 7E 64 4B ED 0B 97 32 3C 1C 5E 93 15 09 8A EE C2
10 98 41 65 70 7C EB C2 35 DC 5E 3E B9 72 24 B1 63 F5 65 59 D9 E4 81 FE C5 12 3F 1D 79 B8 EF 3E 7B 72 EE 55 23 FF A3 C3 E7 C5 08 32 E3 3E
DF AA 9B 94 F0 1F 5C A1 09 39 D5 C3 33 A7 BE 7A DC 3C 3E DD E4 B3 42 72 5F 26 BC 7D 56 58 A0 DF 45 5D 3E FF 72 1A AA 13 D5 0C CD 80 75 73
9E 50 CE A5 2E 6B 78 A2 D6 DE 50 1D 2A 92 36 AD 72 EA 0D CA 57 50 40 39 CA DD 03 E0 F3 7E E9 16 D8 D3 B0 D2 33 50 E9 4C 38 59 36 B1 2A 67
AF 08 1E F6 32 94 23 93 C3 65 2A CA 00 B0 77 19 C5 9A 9C F5 2B DC CB 7F 15 3B C0 66 1D 58 62 6A 7A 26 CD 8E BB B3 DA 1F 2A 58 DB 30 E1 22
E6 49 34 08 41 BD 7E 05 BA 24 C3 65 2A 29 4D DE FA 27 D1 4A 73 7A A6 BB F3 CA 80 E7 2F 5C E2 C9 A1 51 B4 DD D4 94 48 0F 21 9C 2D 22 ED 0E
28 04 94 E0 2F DE 8C AF 6F 9C 20 4F 45 F4 2A 51 6A 2C 15 9B 36 B0 A4 C3 A3 9E A7 7F F2 F0 C8 8D 70 66 22 26 1D DC C1 57 36 23 45 51 F5 5C
F6 18 2C 8A EF BB DC 61 93 14 A8 05 7B B4 10 0C 3F E1 35 C9 BD A0 C5 B9 37 65 64 3B AD 5C 8C DD E1 7C ED 52 F2 F1 41 A1 FF AD F5 10 65 AF
01 8C CC FD 7D 46 98 CC 8A E5 C0 05 09 08 1C D7 5F 36 FF D8 0D E4 3D 4F BA 82 49 34 1D 66 1D 3C EF 87 9D 78 A3 9D 09 F0 0E 7D 62 E6 56 90
EF 53 43 1D E6 E6 E6 DE 59 A7 C1 DD 7C E0 27 FA 21 5F 9A CE FE 6D 7D 5C 26 22 6D 21 3E BB 50 10 4F 27 70 0A 19 92
-
Exception:
System.ArgumentOutOfRangeException: Index and length must refer to a location within the string.
Parameter name: length
   at System.String.Substring(Int32 startIndex, Int32 length)
   at Cryptool.Plugins.HomophonicSubstitutionAnalyzer.HomophoneSubstitutionAnalyzerPresentation.GenerateCiphertextGrid(Text ciphertext, Int32 columns)
   at Cryptool.Plugins.HomophonicSubstitutionAnalyzer.HomophoneSubstitutionAnalyzerPresentation.<>c__DisplayClass32_0.<AddCiphertext>b__0(Object <p0>)
   at System.Windows.Threading.ExceptionWrapper.InternalRealCall(Delegate callback, Object args, Int32 numArgs)
   at System.Windows.Threading.ExceptionWrapper.TryCatchWhen(Object source, Delegate callback, Object args, Int32 numArgs, Delegate catchHandler)
   at System.Windows.Threading.DispatcherOperation.InvokeImpl()
   at MS.Internal.CulturePreservingExecutionContext.CallbackWrapper(Object obj)
   at System.Threading.ExecutionContext.RunInternal(ExecutionContext executionContext, ContextCallback callback, Object state, Boolean preserveSyncCtx)
   at System.Threading.ExecutionContext.Run(ExecutionContext executionContext, ContextCallback callback, Object state, Boolean preserveSyncCtx)
   at System.Threading.ExecutionContext.Run(ExecutionContext executionContext, ContextCallback callback, Object state)
   at MS.Internal.CulturePreservingExecutionContext.Run(CulturePreservingExecutionContext executionContext, ContextCallback callback, Object state)
   at System.Windows.Threading.DispatcherOperation.Invoke()
   at System.Windows.Threading.Dispatcher.ProcessQueue()
   at System.Windows.Threading.Dispatcher.WndProcHook(IntPtr hwnd, Int32 msg, IntPtr wParam, IntPtr lParam, Boolean& handled)
   at MS.Win32.HwndWrapper.WndProc(IntPtr hwnd, Int32 msg, IntPtr wParam, IntPtr lParam, Boolean& handled)
   at MS.Win32.HwndSubclass.DispatcherCallbackOperation(Object o)
   at System.Windows.Threading.ExceptionWrapper.InternalRealCall(Delegate callback, Object args, Int32 numArgs)
   at System.Windows.Threading.ExceptionWrapper.TryCatchWhen(Object source, Delegate callback, Object args, Int32 numArgs, Delegate catchHandler)
   at System.Windows.Threading.Dispatcher.LegacyInvokeImpl(DispatcherPriority priority, TimeSpan timeout, Delegate method, Object args, Int32 numArgs)
   at MS.Win32.HwndSubclass.SubclassWndProc(IntPtr hwnd, Int32 msg, IntPtr wParam, IntPtr lParam)
   at MS.Win32.UnsafeNativeMethods.DispatchMessage(MSG& msg)
   at System.Windows.Threading.Dispatcher.PushFrameImpl(DispatcherFrame frame)
   at System.Windows.Application.RunDispatcher(Object ignore)
   at System.Windows.Application.RunInternal(Window window)
   at Cryptool.CrypWin.App.Main()

-
System infos:
Operating System: Windows 7 Ultimate Service Pack 1 (6.1.7601)
Processorname: Intel(R) Core(TM) i7-6700HQ CPU @ 2.60GHz
Processors: 2
Administrative Rights: False
Current culture: en-US
CrypTool version: 2.1.8186.5
Installation type: NSIS
Build type: Stable
Build time: 6/24/2019 6:10:48 PM
Product name: CrypTool 2.1 (Stable Build 8186.5)
Common language runtime version: 4.0.30319.42000
System time: 9:35 PM
Command line: "C:\Program Files (x86)\CrypTool 2\CrypWin.exe" 


Change History (1)

comment:1 Changed 2 years ago by kopal

Resolution: fixed
Status: newclosed
Summary: Crash report 2020-01-30Homophonic Subst. Analyzer crashed, if a ciphertext with too many homophones was entered

I extended the number of possible homophones (CipherAlphabetText) to 1000 If a user uses more, ? is used Nevertheless, 1000 homophones is unrealistic and would never be broken using the analyzer :-)

Note: See TracTickets for help on using tickets.